---
# tasks file for vcenter
    - block:
        set_fact:
          mount_point: lookup('community.general.random_string')
          
        - name: Creating a Directory to mount the iso file
          file:
            path: "{{ mount_point }}"
            state: directory
            mode: 0777
          become: yes

        - name: Mount vCSA6.7 U2 iso to /mnt/iso directory
          mount:
            path: "{{ mount_point }}"
            src: "{{ iso_path }}"
            fstype: iso9660
            opts: ro,noauto
            state: mounted

        - name: Copying vcsa config to working directory
          template:
            src: "{{ role_path }}/templates/vcsa.json.j2"
            dest: /tmp/vcsa.json

        - name: Test Deployment of VCSA
          shell: | 
              {{ mount_point }}/vcsa-cli-installer/lin64/vcsa-deploy install \
              --no-ssl-certificate-verification \
              --accept-eula \
              --acknowledge-ceip \
              --precheck-only \
              --log-dir /tmp/vcsa.log \
              /tmp/vcsa.json
          args:
            chdir: "{{ mount_point }}/vcsa-cli-installer/lin64/"
          register: vcsa_ret
          failed_when: vcsa_ret.rc != 0

        - name: deployment of vcsa
          shell: |
              {{ mount_point }}/vcsa-cli-installer/lin64/vcsa-deploy install \
              --no-ssl-certificate-verification \
              --accept-eula \
              --acknowledge-ceip \
              --log-dir /tmp/vcsa.log \
              /tmp/vcsa.json
          args:
            chdir: "{{ mount_point }}/vcsa-cli-installer/lin64/"
          register: vcsa_ret
          failed_when: vcsa_ret.rc != 0
      always:
        - name: Unmount vCSA6.7
          mount:
            path: "{{ mount_point }}"
            state: unmounted
        - name: Delete Mount directory
          file:
            path: "{{ mount_point }}"
            state: absent
      when: iso_path is defined and vcenter

    - name: Create Datacenter
      vmware_datacenter:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        datacenter_name: '{{ datacenter_name }}'
        state: present
        validate_certs: no
      delegate_to: localhost

    - name: Create Cluster
      vmware_cluster:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        datacenter_name: "{{ datacenter_name }}"
        cluster_name: "{{ cluster_name }}"
        validate_certs: no
        state: present
      delegate_to: localhost

    - name: Adding Hosts to Datacenter
      vmware_host:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        datacenter: "{{ datacenter_name }}"
        cluster: "{{ cluster_name }}"
        esxi_hostname: '{{ item }}'
        esxi_username: '{{ esx_username }}'
        esxi_password: '{{ esx_password }}'
        state: present
        validate_certs: no
      delegate_to: localhost
      with_items: "{{ esx_hosts }}"

    - name: Starting Create Folders
      include: folders.yml
      when: vm_folders is defined or datastore_folders is defined or network_folders is defined

    - name: Starting Add Licenses
      include: license.yml 
      when: esx_licenses is defined

    - name: Add Datastore to vCenter
      include: storage.yml
      when: nfs_shares is defined
